typeset isofile=""
typeset vobfile=""
typeset dvdpath=""
+typeset aspect=""
+typeset SCALE=""
+typeset CROP=""
typeset -i keep_intermediate_files=0
typeset -i make_final_dest_vob=0
typeset -i make_final_dest_iso=0
typeset -i feature_title_override=0
typeset -i mplayer_dumpstream_incompatibility=0
-while (($#)) && getopts 2mvifkxht:n:d:b:s:t: opt "$@"
+while (($#)) && getopts 2mvifkxht:n:d:b:s:t:a: opt "$@"
do
case $opt in
(n) dvdname=$OPTARG;;
(m) mirror_mode=1;;
(k) keep_intermediate_files=1;;
(t) feature_title_override=$OPTARG;;
+ (a) aspect=$OPTARG;;
(w) set -$opt;;
(h) show_usage=1;;
(:) echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
echo >&2 " You must also specify the target size or bitrate using the '-s' or '-b' options"
echo >&2 " -s <size> Set the target size of the AVI file in MB (ex: 700, 1000, etc)"
echo >&2 " -b <bitrate> Set the bitrate desired in the AVI file in kbits/sec (ex: 1500, 2000 (default), etc)"
+ echo >&2 " -a <W:H> Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
+ echo >&2 " <W> If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
+ echo >&2 " The default behavior is autoaspect mode, which preserves the original aspect."
echo >&2 " -2 Use 2 channel MP3 audio encoding when making an AVI file (default is 6 channel AC3)"
echo >&2 " -k Keep the intermediate files (good for debugging)"
echo >&2 " In -x mode, run with this option to keep the original .VOB file"
echo >&2 " By default, all intermediary files are deleted. Only the final image is kept"
echo >&2 " -t <title> Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
- echo >&2 " -w Set the sh Execute/Verbose flag"
+ echo >&2 " -w Set the sh Execute/Verbose flag (causes every command to be echoed)"
echo >&2 ""
exit 2
}
usage
fi
-if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ]) && [ $make_final_dest_avi -ne 1 ]; then
- echo "-E- You can't specify a bitrate in non AVI file mode. You must specify '-x' when using '-b' or '-s'" | tee -a $logfile
+if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_avi -ne 1 ]; then
+ echo "-E- You can't specify a bitrate, target_size, or aspect in non AVI file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
usage
fi
fi
fi
+# If the aspect ratio option was specified, set the scale variable appropriately for mencoder
+if [ "$aspect" != "" ]; then
+ echo "$aspect" | grep -q "x"
+ if [ $? == 0 ]; then
+ echo "-E- You must specify the aspect option with a value whose format is W:H"
+ exit 1
+ fi
+ echo "$aspect" | grep -q ":"
+ if [ $? != 0 ]; then
+ SCALE="scale -zoom -xy $aspect"
+ else
+ SCALE="scale=$aspect"
+ fi
+fi
+
+
# Sanity Check - Key executables
[[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
[[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
# Edit these as needed to suite your needs
mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
- mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP"
+ mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP,$SCALE"
mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS:chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:bitrate=$target_bitrate:autoaspect:threads=$mencoder_threads"
# There are a number of different ways to encode 6 channel audio.